// Verilog netlist produced by program LSE :  version Diamond (64-bit) 3.12.1.454
// Netlist written on Sun Apr 02 12:26:24 2023
//
// Verilog Description of module top
//

module top (Reset, KeyRows, Cathodes, Segments, LedKeyPressed) /* synthesis syn_module_defined=1 */ ;   // d:/lattice/kurs12/statemachine/source/top.v(1[8:11])
    input Reset;   // d:/lattice/kurs12/statemachine/source/top.v(2[10:15])
    input [3:0]KeyRows;   // d:/lattice/kurs12/statemachine/source/top.v(3[14:21])
    output [7:0]Cathodes;   // d:/lattice/kurs12/statemachine/source/top.v(4[15:23])
    output [7:0]Segments;   // d:/lattice/kurs12/statemachine/source/top.v(5[15:23])
    output LedKeyPressed;   // d:/lattice/kurs12/statemachine/source/top.v(6[11:24])
    
    wire Clock /* synthesis SET_AS_NETWORK=Clock, is_clock=1 */ ;   // d:/lattice/kurs12/statemachine/source/top.v(11[7:12])
    
    wire GND_net, Reset_c, KeyRows_c_3, KeyRows_c_2, KeyRows_c_1, 
        KeyRows_c_0, Cathodes_c_7, Cathodes_c_6, Cathodes_c_5, Cathodes_c_3, 
        Cathodes_c_2, Cathodes_c_1, Segments_c_6, Segments_c_5, Segments_c_4, 
        Segments_c_3, Segments_c_2, Segments_c_1, Segments_c_0, LedKeyPressed_c;
    wire [19:0]Data;   // d:/lattice/kurs12/statemachine/source/top.v(21[13:17])
    wire [4:0]KeyCode;   // d:/lattice/kurs12/statemachine/source/top.v(22[13:20])
    
    wire KeyStrobe, SwitchCathode, n97;
    wire [2:0]State;   // d:/lattice/kurs12/statemachine/source/matrix_keyboard.v(21[12:17])
    
    wire Clock_enable_29, Clock_enable_21, VCC_net, Clock_enable_11, 
        Clock_enable_17, Clock_enable_25, Clock_enable_42, Clock_enable_35, 
        n836, n835, Clock_enable_32, n839;
    
    VHI i749 (.Z(VCC_net));
    OSCH OSCH_inst (.STDBY(GND_net), .OSC(Clock)) /* synthesis syn_instantiated=1 */ ;
    defparam OSCH_inst.NOM_FREQ = "14.00";
    FD1P3AX Data_i0_i0 (.D(KeyCode[0]), .SP(KeyStrobe), .CK(Clock), .Q(Data[0]));   // d:/lattice/kurs12/statemachine/source/top.v(27[8] 28[33])
    defparam Data_i0_i0.GSR = "ENABLED";
    OB Cathodes_pad_6 (.I(Cathodes_c_6), .O(Cathodes[6]));   // d:/lattice/kurs12/statemachine/source/top.v(4[15:23])
    GSR GSR_INST (.GSR(Reset_c));
    FD1P3AX Data_i0_i3 (.D(KeyCode[3]), .SP(KeyStrobe), .CK(Clock), .Q(Data[3]));   // d:/lattice/kurs12/statemachine/source/top.v(27[8] 28[33])
    defparam Data_i0_i3.GSR = "ENABLED";
    IB KeyRows_pad_0 (.I(KeyRows[0]), .O(KeyRows_c_0));   // d:/lattice/kurs12/statemachine/source/top.v(3[14:21])
    IB KeyRows_pad_1 (.I(KeyRows[1]), .O(KeyRows_c_1));   // d:/lattice/kurs12/statemachine/source/top.v(3[14:21])
    IB KeyRows_pad_2 (.I(KeyRows[2]), .O(KeyRows_c_2));   // d:/lattice/kurs12/statemachine/source/top.v(3[14:21])
    IB KeyRows_pad_3 (.I(KeyRows[3]), .O(KeyRows_c_3));   // d:/lattice/kurs12/statemachine/source/top.v(3[14:21])
    IB Reset_pad (.I(Reset), .O(Reset_c));   // d:/lattice/kurs12/statemachine/source/top.v(2[10:15])
    OB LedKeyPressed_pad (.I(LedKeyPressed_c), .O(LedKeyPressed));   // d:/lattice/kurs12/statemachine/source/top.v(6[11:24])
    OB Segments_pad_0 (.I(Segments_c_0), .O(Segments[0]));   // d:/lattice/kurs12/statemachine/source/top.v(5[15:23])
    OB Segments_pad_1 (.I(Segments_c_1), .O(Segments[1]));   // d:/lattice/kurs12/statemachine/source/top.v(5[15:23])
    OB Segments_pad_2 (.I(Segments_c_2), .O(Segments[2]));   // d:/lattice/kurs12/statemachine/source/top.v(5[15:23])
    OB Segments_pad_3 (.I(Segments_c_3), .O(Segments[3]));   // d:/lattice/kurs12/statemachine/source/top.v(5[15:23])
    OB Segments_pad_4 (.I(Segments_c_4), .O(Segments[4]));   // d:/lattice/kurs12/statemachine/source/top.v(5[15:23])
    OB Segments_pad_5 (.I(Segments_c_5), .O(Segments[5]));   // d:/lattice/kurs12/statemachine/source/top.v(5[15:23])
    OB Segments_pad_6 (.I(Segments_c_6), .O(Segments[6]));   // d:/lattice/kurs12/statemachine/source/top.v(5[15:23])
    OB Segments_pad_7 (.I(n839), .O(Segments[7]));   // d:/lattice/kurs12/statemachine/source/top.v(5[15:23])
    OB Cathodes_pad_0 (.I(n835), .O(Cathodes[0]));   // d:/lattice/kurs12/statemachine/source/top.v(4[15:23])
    OB Cathodes_pad_1 (.I(Cathodes_c_1), .O(Cathodes[1]));   // d:/lattice/kurs12/statemachine/source/top.v(4[15:23])
    OB Cathodes_pad_2 (.I(Cathodes_c_2), .O(Cathodes[2]));   // d:/lattice/kurs12/statemachine/source/top.v(4[15:23])
    OB Cathodes_pad_3 (.I(Cathodes_c_3), .O(Cathodes[3]));   // d:/lattice/kurs12/statemachine/source/top.v(4[15:23])
    OB Cathodes_pad_4 (.I(n836), .O(Cathodes[4]));   // d:/lattice/kurs12/statemachine/source/top.v(4[15:23])
    OB Cathodes_pad_5 (.I(Cathodes_c_5), .O(Cathodes[5]));   // d:/lattice/kurs12/statemachine/source/top.v(4[15:23])
    FD1P3AX Data_i0_i2 (.D(KeyCode[2]), .SP(KeyStrobe), .CK(Clock), .Q(Data[2]));   // d:/lattice/kurs12/statemachine/source/top.v(27[8] 28[33])
    defparam Data_i0_i2.GSR = "ENABLED";
    FD1P3AX Data_i0_i1 (.D(KeyCode[1]), .SP(KeyStrobe), .CK(Clock), .Q(Data[1]));   // d:/lattice/kurs12/statemachine/source/top.v(27[8] 28[33])
    defparam Data_i0_i1.GSR = "ENABLED";
    OB Cathodes_pad_7 (.I(Cathodes_c_7), .O(Cathodes[7]));   // d:/lattice/kurs12/statemachine/source/top.v(4[15:23])
    FD1P3AX Data_i0_i19 (.D(Data[14]), .SP(KeyStrobe), .CK(Clock), .Q(Data[19]));   // d:/lattice/kurs12/statemachine/source/top.v(27[8] 28[33])
    defparam Data_i0_i19.GSR = "ENABLED";
    FD1P3AX Data_i0_i18 (.D(Data[13]), .SP(KeyStrobe), .CK(Clock), .Q(Data[18]));   // d:/lattice/kurs12/statemachine/source/top.v(27[8] 28[33])
    defparam Data_i0_i18.GSR = "ENABLED";
    FD1P3AX Data_i0_i17 (.D(Data[12]), .SP(KeyStrobe), .CK(Clock), .Q(Data[17]));   // d:/lattice/kurs12/statemachine/source/top.v(27[8] 28[33])
    defparam Data_i0_i17.GSR = "ENABLED";
    FD1P3AX Data_i0_i16 (.D(Data[11]), .SP(KeyStrobe), .CK(Clock), .Q(Data[16]));   // d:/lattice/kurs12/statemachine/source/top.v(27[8] 28[33])
    defparam Data_i0_i16.GSR = "ENABLED";
    FD1P3AX Data_i0_i15 (.D(Data[10]), .SP(KeyStrobe), .CK(Clock), .Q(Data[15]));   // d:/lattice/kurs12/statemachine/source/top.v(27[8] 28[33])
    defparam Data_i0_i15.GSR = "ENABLED";
    FD1P3AX Data_i0_i14 (.D(Data[9]), .SP(KeyStrobe), .CK(Clock), .Q(Data[14]));   // d:/lattice/kurs12/statemachine/source/top.v(27[8] 28[33])
    defparam Data_i0_i14.GSR = "ENABLED";
    FD1P3AX Data_i0_i13 (.D(Data[8]), .SP(KeyStrobe), .CK(Clock), .Q(Data[13]));   // d:/lattice/kurs12/statemachine/source/top.v(27[8] 28[33])
    defparam Data_i0_i13.GSR = "ENABLED";
    FD1P3AX Data_i0_i12 (.D(Data[7]), .SP(KeyStrobe), .CK(Clock), .Q(Data[12]));   // d:/lattice/kurs12/statemachine/source/top.v(27[8] 28[33])
    defparam Data_i0_i12.GSR = "ENABLED";
    FD1P3AX Data_i0_i11 (.D(Data[6]), .SP(KeyStrobe), .CK(Clock), .Q(Data[11]));   // d:/lattice/kurs12/statemachine/source/top.v(27[8] 28[33])
    defparam Data_i0_i11.GSR = "ENABLED";
    FD1P3AX Data_i0_i10 (.D(Data[5]), .SP(KeyStrobe), .CK(Clock), .Q(Data[10]));   // d:/lattice/kurs12/statemachine/source/top.v(27[8] 28[33])
    defparam Data_i0_i10.GSR = "ENABLED";
    FD1P3AX Data_i0_i9 (.D(Data[4]), .SP(KeyStrobe), .CK(Clock), .Q(Data[9]));   // d:/lattice/kurs12/statemachine/source/top.v(27[8] 28[33])
    defparam Data_i0_i9.GSR = "ENABLED";
    FD1P3AX Data_i0_i8 (.D(Data[3]), .SP(KeyStrobe), .CK(Clock), .Q(Data[8]));   // d:/lattice/kurs12/statemachine/source/top.v(27[8] 28[33])
    defparam Data_i0_i8.GSR = "ENABLED";
    FD1P3AX Data_i0_i7 (.D(Data[2]), .SP(KeyStrobe), .CK(Clock), .Q(Data[7]));   // d:/lattice/kurs12/statemachine/source/top.v(27[8] 28[33])
    defparam Data_i0_i7.GSR = "ENABLED";
    FD1P3AX Data_i0_i6 (.D(Data[1]), .SP(KeyStrobe), .CK(Clock), .Q(Data[6]));   // d:/lattice/kurs12/statemachine/source/top.v(27[8] 28[33])
    defparam Data_i0_i6.GSR = "ENABLED";
    FD1P3AX Data_i0_i5 (.D(Data[0]), .SP(KeyStrobe), .CK(Clock), .Q(Data[5]));   // d:/lattice/kurs12/statemachine/source/top.v(27[8] 28[33])
    defparam Data_i0_i5.GSR = "ENABLED";
    FD1P3AX Data_i0_i4 (.D(KeyCode[4]), .SP(KeyStrobe), .CK(Clock), .Q(Data[4]));   // d:/lattice/kurs12/statemachine/source/top.v(27[8] 28[33])
    defparam Data_i0_i4.GSR = "ENABLED";
    VLO i1 (.Z(GND_net));
    TSALL TSALL_INST (.TSALL(GND_net));
    PUR PUR_INST (.PUR(VCC_net));
    defparam PUR_INST.RST_PULSE = 1;
    MatrixKeyboard MatrixKeyboard0 (.Clock(Clock), .Clock_enable_42(Clock_enable_42), 
            .KeyRows_c_1(KeyRows_c_1), .KeyRows_c_0(KeyRows_c_0), .Clock_enable_11(Clock_enable_11), 
            .KeyRows_c_3(KeyRows_c_3), .KeyRows_c_2(KeyRows_c_2), .Clock_enable_32(Clock_enable_32), 
            .LedKeyPressed_c(LedKeyPressed_c), .Clock_enable_35(Clock_enable_35), 
            .KeyCode({KeyCode}), .KeyStrobe(KeyStrobe), .SwitchCathode(SwitchCathode), 
            .Clock_enable_17(Clock_enable_17), .Clock_enable_21(Clock_enable_21), 
            .Clock_enable_25(Clock_enable_25), .Clock_enable_29(Clock_enable_29), 
            .\State[1] (State[1]), .n97(n97)) /* synthesis syn_module_defined=1 */ ;   // d:/lattice/kurs12/statemachine/source/top.v(58[17] 67[3])
    \DisplayMultiplex(FREQUENCY_HZ=14000000,SWITCH_PERIOD_US=2000)  DisplayMultiplex0 (.Data({Data}), 
            .Clock(Clock), .SwitchCathode(SwitchCathode), .n839(n839), 
            .Cathodes_c_1(Cathodes_c_1), .\State[1] (State[1]), .Clock_enable_35(Clock_enable_35), 
            .Cathodes_c_2(Cathodes_c_2), .Cathodes_c_6(Cathodes_c_6), .Clock_enable_21(Clock_enable_21), 
            .Cathodes_c_3(Cathodes_c_3), .Clock_enable_11(Clock_enable_11), 
            .Clock_enable_25(Clock_enable_25), .Clock_enable_42(Clock_enable_42), 
            .Clock_enable_32(Clock_enable_32), .n835(n835), .Clock_enable_17(Clock_enable_17), 
            .Clock_enable_29(Clock_enable_29), .n836(n836), .Cathodes_c_5(Cathodes_c_5), 
            .Cathodes_c_7(Cathodes_c_7), .GND_net(GND_net), .n97(n97), 
            .Segments_c_6(Segments_c_6), .Segments_c_0(Segments_c_0), .Segments_c_1(Segments_c_1), 
            .Segments_c_4(Segments_c_4), .Segments_c_3(Segments_c_3), .Segments_c_5(Segments_c_5), 
            .Segments_c_2(Segments_c_2)) /* synthesis syn_module_defined=1 */ ;   // d:/lattice/kurs12/statemachine/source/top.v(47[4] 55[3])
    
endmodule
//
// Verilog Description of module TSALL
// module not written out since it is a black-box. 
//

//
// Verilog Description of module PUR
// module not written out since it is a black-box. 
//

//
// Verilog Description of module MatrixKeyboard
//

module MatrixKeyboard (Clock, Clock_enable_42, KeyRows_c_1, KeyRows_c_0, 
            Clock_enable_11, KeyRows_c_3, KeyRows_c_2, Clock_enable_32, 
            LedKeyPressed_c, Clock_enable_35, KeyCode, KeyStrobe, SwitchCathode, 
            Clock_enable_17, Clock_enable_21, Clock_enable_25, Clock_enable_29, 
            \State[1] , n97) /* synthesis syn_module_defined=1 */ ;
    input Clock;
    input Clock_enable_42;
    input KeyRows_c_1;
    input KeyRows_c_0;
    input Clock_enable_11;
    input KeyRows_c_3;
    input KeyRows_c_2;
    input Clock_enable_32;
    output LedKeyPressed_c;
    input Clock_enable_35;
    output [4:0]KeyCode;
    output KeyStrobe;
    input SwitchCathode;
    input Clock_enable_17;
    input Clock_enable_21;
    input Clock_enable_25;
    input Clock_enable_29;
    output \State[1] ;
    input n97;
    
    wire Clock /* synthesis SET_AS_NETWORK=Clock, is_clock=1 */ ;   // d:/lattice/kurs12/statemachine/source/top.v(11[7:12])
    wire [4:0]KeyCounter;   // d:/lattice/kurs12/statemachine/source/matrix_keyboard.v(17[13:23])
    
    wire n837, n838;
    wire [31:0]KeyBuffer;   // d:/lattice/kurs12/statemachine/source/matrix_keyboard.v(18[13:22])
    
    wire Clock_enable_43, n417;
    wire [4:0]n45;
    
    wire n728, n727, n726, KeyPressed_N_186;
    wire [2:0]State;   // d:/lattice/kurs12/statemachine/source/matrix_keyboard.v(21[12:17])
    
    wire Clock_enable_41, n730, n729, n715, n716, n731, Clock_enable_7, 
        KeyPressedPrevious, KeyStrobe_N_182, n717, n718, n732, n743, 
        n744, n725, n719, n720, n733, n834, n335, n721, n722, 
        n734, n1, n723, n724, n735, n315, KeyPressed_N_188, n739, 
        n740, n741, n742, n736, n737, n738;
    
    LUT4 i131_2_lut_rep_13_3_lut (.A(KeyCounter[0]), .B(KeyCounter[1]), 
         .C(KeyCounter[2]), .Z(n837)) /* synthesis lut_function=(A (B (C))) */ ;   // d:/lattice/kurs12/statemachine/source/matrix_keyboard.v(66[18:29])
    defparam i131_2_lut_rep_13_3_lut.init = 16'h8080;
    LUT4 KeyCounter_4__I_0_88_i1_2_lut_rep_14 (.A(KeyCounter[0]), .B(KeyCounter[1]), 
         .Z(n838)) /* synthesis lut_function=(A (B)) */ ;   // d:/lattice/kurs12/statemachine/source/matrix_keyboard.v(66[18:29])
    defparam KeyCounter_4__I_0_88_i1_2_lut_rep_14.init = 16'h8888;
    FD1P3AX KeyBuffer_i0_i5 (.D(KeyRows_c_1), .SP(Clock_enable_42), .CK(Clock), 
            .Q(KeyBuffer[5])) /* synthesis LSE_LINE_FILE_ID=7, LSE_LCOL=17, LSE_RCOL=3, LSE_LLINE=58, LSE_RLINE=67 */ ;   // d:/lattice/kurs12/statemachine/source/matrix_keyboard.v(33[12] 79[6])
    defparam KeyBuffer_i0_i5.GSR = "ENABLED";
    FD1P3IX KeyCounter_i0_i2 (.D(n45[2]), .SP(Clock_enable_43), .CD(n417), 
            .CK(Clock), .Q(KeyCounter[2])) /* synthesis LSE_LINE_FILE_ID=7, LSE_LCOL=17, LSE_RCOL=3, LSE_LLINE=58, LSE_RLINE=67 */ ;   // d:/lattice/kurs12/statemachine/source/matrix_keyboard.v(33[12] 79[6])
    defparam KeyCounter_i0_i2.GSR = "ENABLED";
    FD1P3AX KeyBuffer_i0_i4 (.D(KeyRows_c_0), .SP(Clock_enable_42), .CK(Clock), 
            .Q(KeyBuffer[4])) /* synthesis LSE_LINE_FILE_ID=7, LSE_LCOL=17, LSE_RCOL=3, LSE_LLINE=58, LSE_RLINE=67 */ ;   // d:/lattice/kurs12/statemachine/source/matrix_keyboard.v(33[12] 79[6])
    defparam KeyBuffer_i0_i4.GSR = "ENABLED";
    FD1P3AX KeyBuffer_i0_i3 (.D(KeyRows_c_3), .SP(Clock_enable_11), .CK(Clock), 
            .Q(KeyBuffer[3])) /* synthesis LSE_LINE_FILE_ID=7, LSE_LCOL=17, LSE_RCOL=3, LSE_LLINE=58, LSE_RLINE=67 */ ;   // d:/lattice/kurs12/statemachine/source/matrix_keyboard.v(33[12] 79[6])
    defparam KeyBuffer_i0_i3.GSR = "ENABLED";
    FD1P3AX KeyBuffer_i0_i2 (.D(KeyRows_c_2), .SP(Clock_enable_11), .CK(Clock), 
            .Q(KeyBuffer[2])) /* synthesis LSE_LINE_FILE_ID=7, LSE_LCOL=17, LSE_RCOL=3, LSE_LLINE=58, LSE_RLINE=67 */ ;   // d:/lattice/kurs12/statemachine/source/matrix_keyboard.v(33[12] 79[6])
    defparam KeyBuffer_i0_i2.GSR = "ENABLED";
    LUT4 i626_3_lut (.A(KeyBuffer[26]), .B(KeyBuffer[27]), .C(KeyCounter[0]), 
         .Z(n728)) /* synthesis lut_function=(A (B+!(C))+!A (B (C))) */ ;
    defparam i626_3_lut.init = 16'hcaca;
    LUT4 i625_3_lut (.A(KeyBuffer[24]), .B(KeyBuffer[25]), .C(KeyCounter[0]), 
         .Z(n727)) /* synthesis lut_function=(A (B+!(C))+!A (B (C))) */ ;
    defparam i625_3_lut.init = 16'hcaca;
    LUT4 i624_3_lut (.A(KeyBuffer[22]), .B(KeyBuffer[23]), .C(KeyCounter[0]), 
         .Z(n726)) /* synthesis lut_function=(A (B+!(C))+!A (B (C))) */ ;
    defparam i624_3_lut.init = 16'hcaca;
    LUT4 i56_2_lut (.A(KeyPressed_N_186), .B(State[2]), .Z(Clock_enable_41)) /* synthesis lut_function=(A (B)) */ ;   // d:/lattice/kurs12/statemachine/source/matrix_keyboard.v(34[4] 78[11])
    defparam i56_2_lut.init = 16'h8888;
    LUT4 i129_2_lut_3_lut (.A(KeyCounter[0]), .B(KeyCounter[1]), .C(KeyCounter[2]), 
         .Z(n45[2])) /* synthesis lut_function=(!(A (B (C)+!B !(C))+!A !(C))) */ ;   // d:/lattice/kurs12/statemachine/source/matrix_keyboard.v(66[18:29])
    defparam i129_2_lut_3_lut.init = 16'h7878;
    LUT4 i628_3_lut (.A(KeyBuffer[30]), .B(KeyBuffer[31]), .C(KeyCounter[0]), 
         .Z(n730)) /* synthesis lut_function=(A (B+!(C))+!A (B (C))) */ ;
    defparam i628_3_lut.init = 16'hcaca;
    LUT4 i627_3_lut (.A(KeyBuffer[28]), .B(KeyBuffer[29]), .C(KeyCounter[0]), 
         .Z(n729)) /* synthesis lut_function=(A (B+!(C))+!A (B (C))) */ ;
    defparam i627_3_lut.init = 16'hcaca;
    LUT4 i122_2_lut (.A(KeyCounter[1]), .B(KeyCounter[0]), .Z(n45[1])) /* synthesis lut_function=(!(A (B)+!A !(B))) */ ;   // d:/lattice/kurs12/statemachine/source/matrix_keyboard.v(70[22:39])
    defparam i122_2_lut.init = 16'h6666;
    FD1P3AX KeyBuffer_i0_i13 (.D(KeyRows_c_1), .SP(Clock_enable_32), .CK(Clock), 
            .Q(KeyBuffer[13])) /* synthesis LSE_LINE_FILE_ID=7, LSE_LCOL=17, LSE_RCOL=3, LSE_LLINE=58, LSE_RLINE=67 */ ;   // d:/lattice/kurs12/statemachine/source/matrix_keyboard.v(33[12] 79[6])
    defparam KeyBuffer_i0_i13.GSR = "ENABLED";
    PFUMX i629 (.BLUT(n715), .ALUT(n716), .C0(KeyCounter[1]), .Z(n731));
    FD1P3AX KeyPressed_75 (.D(KeyPressed_N_186), .SP(Clock_enable_7), .CK(Clock), 
            .Q(LedKeyPressed_c)) /* synthesis LSE_LINE_FILE_ID=7, LSE_LCOL=17, LSE_RCOL=3, LSE_LLINE=58, LSE_RLINE=67 */ ;   // d:/lattice/kurs12/statemachine/source/matrix_keyboard.v(33[12] 79[6])
    defparam KeyPressed_75.GSR = "ENABLED";
    FD1P3AX KeyBuffer_i0_i8 (.D(KeyRows_c_0), .SP(Clock_enable_35), .CK(Clock), 
            .Q(KeyBuffer[8])) /* synthesis LSE_LINE_FILE_ID=7, LSE_LCOL=17, LSE_RCOL=3, LSE_LLINE=58, LSE_RLINE=67 */ ;   // d:/lattice/kurs12/statemachine/source/matrix_keyboard.v(33[12] 79[6])
    defparam KeyBuffer_i0_i8.GSR = "ENABLED";
    FD1P3AX KeyBuffer_i0_i0 (.D(KeyRows_c_0), .SP(Clock_enable_11), .CK(Clock), 
            .Q(KeyBuffer[0])) /* synthesis LSE_LINE_FILE_ID=7, LSE_LCOL=17, LSE_RCOL=3, LSE_LLINE=58, LSE_RLINE=67 */ ;   // d:/lattice/kurs12/statemachine/source/matrix_keyboard.v(33[12] 79[6])
    defparam KeyBuffer_i0_i0.GSR = "ENABLED";
    FD1P3AX KeyBuffer_i0_i7 (.D(KeyRows_c_3), .SP(Clock_enable_42), .CK(Clock), 
            .Q(KeyBuffer[7])) /* synthesis LSE_LINE_FILE_ID=7, LSE_LCOL=17, LSE_RCOL=3, LSE_LLINE=58, LSE_RLINE=67 */ ;   // d:/lattice/kurs12/statemachine/source/matrix_keyboard.v(33[12] 79[6])
    defparam KeyBuffer_i0_i7.GSR = "ENABLED";
    LUT4 KeyStrobe_I_0_2_lut (.A(KeyPressedPrevious), .B(LedKeyPressed_c), 
         .Z(KeyStrobe_N_182)) /* synthesis lut_function=(!(A+!(B))) */ ;   // d:/lattice/kurs12/statemachine/source/matrix_keyboard.v(90[7:40])
    defparam KeyStrobe_I_0_2_lut.init = 16'h4444;
    FD1P3AX KeyBuffer_i0_i1 (.D(KeyRows_c_1), .SP(Clock_enable_11), .CK(Clock), 
            .Q(KeyBuffer[1])) /* synthesis LSE_LINE_FILE_ID=7, LSE_LCOL=17, LSE_RCOL=3, LSE_LLINE=58, LSE_RLINE=67 */ ;   // d:/lattice/kurs12/statemachine/source/matrix_keyboard.v(33[12] 79[6])
    defparam KeyBuffer_i0_i1.GSR = "ENABLED";
    PFUMX i630 (.BLUT(n717), .ALUT(n718), .C0(KeyCounter[1]), .Z(n732));
    FD1P3AX KeyCode_i0_i0 (.D(KeyCounter[0]), .SP(Clock_enable_41), .CK(Clock), 
            .Q(KeyCode[0])) /* synthesis LSE_LINE_FILE_ID=7, LSE_LCOL=17, LSE_RCOL=3, LSE_LLINE=58, LSE_RLINE=67 */ ;   // d:/lattice/kurs12/statemachine/source/matrix_keyboard.v(33[12] 79[6])
    defparam KeyCode_i0_i0.GSR = "ENABLED";
    FD1S3AX KeyStrobe_78 (.D(KeyStrobe_N_182), .CK(Clock), .Q(KeyStrobe)) /* synthesis LSE_LINE_FILE_ID=7, LSE_LCOL=17, LSE_RCOL=3, LSE_LLINE=58, LSE_RLINE=67 */ ;   // d:/lattice/kurs12/statemachine/source/matrix_keyboard.v(88[12] 94[6])
    defparam KeyStrobe_78.GSR = "ENABLED";
    FD1S3AX KeyPressedPrevious_79 (.D(LedKeyPressed_c), .CK(Clock), .Q(KeyPressedPrevious)) /* synthesis LSE_LINE_FILE_ID=7, LSE_LCOL=17, LSE_RCOL=3, LSE_LLINE=58, LSE_RLINE=67 */ ;   // d:/lattice/kurs12/statemachine/source/matrix_keyboard.v(88[12] 94[6])
    defparam KeyPressedPrevious_79.GSR = "ENABLED";
    LUT4 i643_3_lut (.A(n743), .B(n744), .C(KeyCounter[4]), .Z(KeyPressed_N_186)) /* synthesis lut_function=(A (B+!(C))+!A (B (C))) */ ;
    defparam i643_3_lut.init = 16'hcaca;
    LUT4 i623_3_lut (.A(KeyBuffer[20]), .B(KeyBuffer[21]), .C(KeyCounter[0]), 
         .Z(n725)) /* synthesis lut_function=(A (B+!(C))+!A (B (C))) */ ;
    defparam i623_3_lut.init = 16'hcaca;
    PFUMX i631 (.BLUT(n719), .ALUT(n720), .C0(KeyCounter[1]), .Z(n733));
    LUT4 i230_3_lut_4_lut (.A(n834), .B(State[2]), .C(SwitchCathode), 
         .D(State[0]), .Z(n335)) /* synthesis lut_function=(A (B+!(C+!(D)))+!A !(C+!(D))) */ ;   // d:/lattice/kurs12/statemachine/source/matrix_keyboard.v(34[4] 78[11])
    defparam i230_3_lut_4_lut.init = 16'h8f88;
    PFUMX i632 (.BLUT(n721), .ALUT(n722), .C0(KeyCounter[1]), .Z(n734));
    LUT4 i136_2_lut_3_lut_4_lut (.A(KeyCounter[0]), .B(KeyCounter[1]), .C(KeyCounter[3]), 
         .D(KeyCounter[2]), .Z(n45[3])) /* synthesis lut_function=(!(A (B (C (D)+!C !(D))+!B !(C))+!A !(C))) */ ;   // d:/lattice/kurs12/statemachine/source/matrix_keyboard.v(66[18:29])
    defparam i136_2_lut_3_lut_4_lut.init = 16'h78f0;
    FD1P3AX KeyCounter_i0_i0 (.D(n1), .SP(Clock_enable_43), .CK(Clock), 
            .Q(KeyCounter[0])) /* synthesis LSE_LINE_FILE_ID=7, LSE_LCOL=17, LSE_RCOL=3, LSE_LLINE=58, LSE_RLINE=67 */ ;   // d:/lattice/kurs12/statemachine/source/matrix_keyboard.v(33[12] 79[6])
    defparam KeyCounter_i0_i0.GSR = "ENABLED";
    LUT4 select_64_Select_0_i1_2_lut (.A(KeyCounter[0]), .B(State[2]), .Z(n1)) /* synthesis lut_function=(!(A+!(B))) */ ;
    defparam select_64_Select_0_i1_2_lut.init = 16'h4444;
    PFUMX i633 (.BLUT(n723), .ALUT(n724), .C0(KeyCounter[1]), .Z(n735));
    FD1S3AX State_FSM_i0 (.D(n315), .CK(Clock), .Q(State[2]));   // d:/lattice/kurs12/statemachine/source/matrix_keyboard.v(34[4] 78[11])
    defparam State_FSM_i0.GSR = "ENABLED";
    LUT4 i143_3_lut_4_lut (.A(KeyCounter[2]), .B(n838), .C(KeyCounter[3]), 
         .D(KeyCounter[4]), .Z(n45[4])) /* synthesis lut_function=(!(A (B (C (D)+!C !(D))+!B !(D))+!A !(D))) */ ;   // d:/lattice/kurs12/statemachine/source/matrix_keyboard.v(70[22:39])
    defparam i143_3_lut_4_lut.init = 16'h7f80;
    LUT4 i614_3_lut (.A(KeyBuffer[2]), .B(KeyBuffer[3]), .C(KeyCounter[0]), 
         .Z(n716)) /* synthesis lut_function=(A (B+!(C))+!A (B (C))) */ ;
    defparam i614_3_lut.init = 16'hcaca;
    LUT4 i622_3_lut (.A(KeyBuffer[18]), .B(KeyBuffer[19]), .C(KeyCounter[0]), 
         .Z(n724)) /* synthesis lut_function=(A (B+!(C))+!A (B (C))) */ ;
    defparam i622_3_lut.init = 16'hcaca;
    LUT4 i621_3_lut (.A(KeyBuffer[16]), .B(KeyBuffer[17]), .C(KeyCounter[0]), 
         .Z(n723)) /* synthesis lut_function=(A (B+!(C))+!A (B (C))) */ ;
    defparam i621_3_lut.init = 16'hcaca;
    FD1P3AX KeyBuffer_i0_i31 (.D(KeyRows_c_3), .SP(Clock_enable_17), .CK(Clock), 
            .Q(KeyBuffer[31])) /* synthesis LSE_LINE_FILE_ID=7, LSE_LCOL=17, LSE_RCOL=3, LSE_LLINE=58, LSE_RLINE=67 */ ;   // d:/lattice/kurs12/statemachine/source/matrix_keyboard.v(33[12] 79[6])
    defparam KeyBuffer_i0_i31.GSR = "ENABLED";
    FD1P3AX KeyBuffer_i0_i30 (.D(KeyRows_c_2), .SP(Clock_enable_17), .CK(Clock), 
            .Q(KeyBuffer[30])) /* synthesis LSE_LINE_FILE_ID=7, LSE_LCOL=17, LSE_RCOL=3, LSE_LLINE=58, LSE_RLINE=67 */ ;   // d:/lattice/kurs12/statemachine/source/matrix_keyboard.v(33[12] 79[6])
    defparam KeyBuffer_i0_i30.GSR = "ENABLED";
    FD1P3AX KeyBuffer_i0_i29 (.D(KeyRows_c_1), .SP(Clock_enable_17), .CK(Clock), 
            .Q(KeyBuffer[29])) /* synthesis LSE_LINE_FILE_ID=7, LSE_LCOL=17, LSE_RCOL=3, LSE_LLINE=58, LSE_RLINE=67 */ ;   // d:/lattice/kurs12/statemachine/source/matrix_keyboard.v(33[12] 79[6])
    defparam KeyBuffer_i0_i29.GSR = "ENABLED";
    FD1P3AX KeyBuffer_i0_i28 (.D(KeyRows_c_0), .SP(Clock_enable_17), .CK(Clock), 
            .Q(KeyBuffer[28])) /* synthesis LSE_LINE_FILE_ID=7, LSE_LCOL=17, LSE_RCOL=3, LSE_LLINE=58, LSE_RLINE=67 */ ;   // d:/lattice/kurs12/statemachine/source/matrix_keyboard.v(33[12] 79[6])
    defparam KeyBuffer_i0_i28.GSR = "ENABLED";
    FD1P3AX KeyBuffer_i0_i27 (.D(KeyRows_c_3), .SP(Clock_enable_21), .CK(Clock), 
            .Q(KeyBuffer[27])) /* synthesis LSE_LINE_FILE_ID=7, LSE_LCOL=17, LSE_RCOL=3, LSE_LLINE=58, LSE_RLINE=67 */ ;   // d:/lattice/kurs12/statemachine/source/matrix_keyboard.v(33[12] 79[6])
    defparam KeyBuffer_i0_i27.GSR = "ENABLED";
    FD1P3AX KeyBuffer_i0_i26 (.D(KeyRows_c_2), .SP(Clock_enable_21), .CK(Clock), 
            .Q(KeyBuffer[26])) /* synthesis LSE_LINE_FILE_ID=7, LSE_LCOL=17, LSE_RCOL=3, LSE_LLINE=58, LSE_RLINE=67 */ ;   // d:/lattice/kurs12/statemachine/source/matrix_keyboard.v(33[12] 79[6])
    defparam KeyBuffer_i0_i26.GSR = "ENABLED";
    FD1P3AX KeyBuffer_i0_i25 (.D(KeyRows_c_1), .SP(Clock_enable_21), .CK(Clock), 
            .Q(KeyBuffer[25])) /* synthesis LSE_LINE_FILE_ID=7, LSE_LCOL=17, LSE_RCOL=3, LSE_LLINE=58, LSE_RLINE=67 */ ;   // d:/lattice/kurs12/statemachine/source/matrix_keyboard.v(33[12] 79[6])
    defparam KeyBuffer_i0_i25.GSR = "ENABLED";
    FD1P3AX KeyBuffer_i0_i24 (.D(KeyRows_c_0), .SP(Clock_enable_21), .CK(Clock), 
            .Q(KeyBuffer[24])) /* synthesis LSE_LINE_FILE_ID=7, LSE_LCOL=17, LSE_RCOL=3, LSE_LLINE=58, LSE_RLINE=67 */ ;   // d:/lattice/kurs12/statemachine/source/matrix_keyboard.v(33[12] 79[6])
    defparam KeyBuffer_i0_i24.GSR = "ENABLED";
    FD1P3AX KeyBuffer_i0_i23 (.D(KeyRows_c_3), .SP(Clock_enable_25), .CK(Clock), 
            .Q(KeyBuffer[23])) /* synthesis LSE_LINE_FILE_ID=7, LSE_LCOL=17, LSE_RCOL=3, LSE_LLINE=58, LSE_RLINE=67 */ ;   // d:/lattice/kurs12/statemachine/source/matrix_keyboard.v(33[12] 79[6])
    defparam KeyBuffer_i0_i23.GSR = "ENABLED";
    FD1P3AX KeyBuffer_i0_i22 (.D(KeyRows_c_2), .SP(Clock_enable_25), .CK(Clock), 
            .Q(KeyBuffer[22])) /* synthesis LSE_LINE_FILE_ID=7, LSE_LCOL=17, LSE_RCOL=3, LSE_LLINE=58, LSE_RLINE=67 */ ;   // d:/lattice/kurs12/statemachine/source/matrix_keyboard.v(33[12] 79[6])
    defparam KeyBuffer_i0_i22.GSR = "ENABLED";
    FD1P3AX KeyBuffer_i0_i21 (.D(KeyRows_c_1), .SP(Clock_enable_25), .CK(Clock), 
            .Q(KeyBuffer[21])) /* synthesis LSE_LINE_FILE_ID=7, LSE_LCOL=17, LSE_RCOL=3, LSE_LLINE=58, LSE_RLINE=67 */ ;   // d:/lattice/kurs12/statemachine/source/matrix_keyboard.v(33[12] 79[6])
    defparam KeyBuffer_i0_i21.GSR = "ENABLED";
    FD1P3AX KeyBuffer_i0_i20 (.D(KeyRows_c_0), .SP(Clock_enable_25), .CK(Clock), 
            .Q(KeyBuffer[20])) /* synthesis LSE_LINE_FILE_ID=7, LSE_LCOL=17, LSE_RCOL=3, LSE_LLINE=58, LSE_RLINE=67 */ ;   // d:/lattice/kurs12/statemachine/source/matrix_keyboard.v(33[12] 79[6])
    defparam KeyBuffer_i0_i20.GSR = "ENABLED";
    FD1P3AX KeyBuffer_i0_i19 (.D(KeyRows_c_3), .SP(Clock_enable_29), .CK(Clock), 
            .Q(KeyBuffer[19])) /* synthesis LSE_LINE_FILE_ID=7, LSE_LCOL=17, LSE_RCOL=3, LSE_LLINE=58, LSE_RLINE=67 */ ;   // d:/lattice/kurs12/statemachine/source/matrix_keyboard.v(33[12] 79[6])
    defparam KeyBuffer_i0_i19.GSR = "ENABLED";
    FD1P3AX KeyBuffer_i0_i18 (.D(KeyRows_c_2), .SP(Clock_enable_29), .CK(Clock), 
            .Q(KeyBuffer[18])) /* synthesis LSE_LINE_FILE_ID=7, LSE_LCOL=17, LSE_RCOL=3, LSE_LLINE=58, LSE_RLINE=67 */ ;   // d:/lattice/kurs12/statemachine/source/matrix_keyboard.v(33[12] 79[6])
    defparam KeyBuffer_i0_i18.GSR = "ENABLED";
    FD1P3AX KeyBuffer_i0_i17 (.D(KeyRows_c_1), .SP(Clock_enable_29), .CK(Clock), 
            .Q(KeyBuffer[17])) /* synthesis LSE_LINE_FILE_ID=7, LSE_LCOL=17, LSE_RCOL=3, LSE_LLINE=58, LSE_RLINE=67 */ ;   // d:/lattice/kurs12/statemachine/source/matrix_keyboard.v(33[12] 79[6])
    defparam KeyBuffer_i0_i17.GSR = "ENABLED";
    FD1P3AX KeyBuffer_i0_i16 (.D(KeyRows_c_0), .SP(Clock_enable_29), .CK(Clock), 
            .Q(KeyBuffer[16])) /* synthesis LSE_LINE_FILE_ID=7, LSE_LCOL=17, LSE_RCOL=3, LSE_LLINE=58, LSE_RLINE=67 */ ;   // d:/lattice/kurs12/statemachine/source/matrix_keyboard.v(33[12] 79[6])
    defparam KeyBuffer_i0_i16.GSR = "ENABLED";
    FD1P3AX KeyBuffer_i0_i15 (.D(KeyRows_c_3), .SP(Clock_enable_32), .CK(Clock), 
            .Q(KeyBuffer[15])) /* synthesis LSE_LINE_FILE_ID=7, LSE_LCOL=17, LSE_RCOL=3, LSE_LLINE=58, LSE_RLINE=67 */ ;   // d:/lattice/kurs12/statemachine/source/matrix_keyboard.v(33[12] 79[6])
    defparam KeyBuffer_i0_i15.GSR = "ENABLED";
    FD1P3AX KeyBuffer_i0_i14 (.D(KeyRows_c_2), .SP(Clock_enable_32), .CK(Clock), 
            .Q(KeyBuffer[14])) /* synthesis LSE_LINE_FILE_ID=7, LSE_LCOL=17, LSE_RCOL=3, LSE_LLINE=58, LSE_RLINE=67 */ ;   // d:/lattice/kurs12/statemachine/source/matrix_keyboard.v(33[12] 79[6])
    defparam KeyBuffer_i0_i14.GSR = "ENABLED";
    FD1P3AX KeyBuffer_i0_i12 (.D(KeyRows_c_0), .SP(Clock_enable_32), .CK(Clock), 
            .Q(KeyBuffer[12])) /* synthesis LSE_LINE_FILE_ID=7, LSE_LCOL=17, LSE_RCOL=3, LSE_LLINE=58, LSE_RLINE=67 */ ;   // d:/lattice/kurs12/statemachine/source/matrix_keyboard.v(33[12] 79[6])
    defparam KeyBuffer_i0_i12.GSR = "ENABLED";
    FD1P3AX KeyBuffer_i0_i11 (.D(KeyRows_c_3), .SP(Clock_enable_35), .CK(Clock), 
            .Q(KeyBuffer[11])) /* synthesis LSE_LINE_FILE_ID=7, LSE_LCOL=17, LSE_RCOL=3, LSE_LLINE=58, LSE_RLINE=67 */ ;   // d:/lattice/kurs12/statemachine/source/matrix_keyboard.v(33[12] 79[6])
    defparam KeyBuffer_i0_i11.GSR = "ENABLED";
    FD1P3AX KeyBuffer_i0_i10 (.D(KeyRows_c_2), .SP(Clock_enable_35), .CK(Clock), 
            .Q(KeyBuffer[10])) /* synthesis LSE_LINE_FILE_ID=7, LSE_LCOL=17, LSE_RCOL=3, LSE_LLINE=58, LSE_RLINE=67 */ ;   // d:/lattice/kurs12/statemachine/source/matrix_keyboard.v(33[12] 79[6])
    defparam KeyBuffer_i0_i10.GSR = "ENABLED";
    FD1P3AX KeyBuffer_i0_i9 (.D(KeyRows_c_1), .SP(Clock_enable_35), .CK(Clock), 
            .Q(KeyBuffer[9])) /* synthesis LSE_LINE_FILE_ID=7, LSE_LCOL=17, LSE_RCOL=3, LSE_LLINE=58, LSE_RLINE=67 */ ;   // d:/lattice/kurs12/statemachine/source/matrix_keyboard.v(33[12] 79[6])
    defparam KeyBuffer_i0_i9.GSR = "ENABLED";
    FD1P3IX KeyCounter_i0_i4 (.D(n45[4]), .SP(Clock_enable_43), .CD(n417), 
            .CK(Clock), .Q(KeyCounter[4])) /* synthesis LSE_LINE_FILE_ID=7, LSE_LCOL=17, LSE_RCOL=3, LSE_LLINE=58, LSE_RLINE=67 */ ;   // d:/lattice/kurs12/statemachine/source/matrix_keyboard.v(33[12] 79[6])
    defparam KeyCounter_i0_i4.GSR = "ENABLED";
    FD1P3IX KeyCounter_i0_i1 (.D(n45[1]), .SP(Clock_enable_43), .CD(n417), 
            .CK(Clock), .Q(KeyCounter[1])) /* synthesis LSE_LINE_FILE_ID=7, LSE_LCOL=17, LSE_RCOL=3, LSE_LLINE=58, LSE_RLINE=67 */ ;   // d:/lattice/kurs12/statemachine/source/matrix_keyboard.v(33[12] 79[6])
    defparam KeyCounter_i0_i1.GSR = "ENABLED";
    LUT4 i620_3_lut (.A(KeyBuffer[14]), .B(KeyBuffer[15]), .C(KeyCounter[0]), 
         .Z(n722)) /* synthesis lut_function=(A (B+!(C))+!A (B (C))) */ ;
    defparam i620_3_lut.init = 16'hcaca;
    LUT4 i619_3_lut (.A(KeyBuffer[12]), .B(KeyBuffer[13]), .C(KeyCounter[0]), 
         .Z(n721)) /* synthesis lut_function=(A (B+!(C))+!A (B (C))) */ ;
    defparam i619_3_lut.init = 16'hcaca;
    FD1P3AX KeyCode_i0_i4 (.D(KeyCounter[4]), .SP(Clock_enable_41), .CK(Clock), 
            .Q(KeyCode[4])) /* synthesis LSE_LINE_FILE_ID=7, LSE_LCOL=17, LSE_RCOL=3, LSE_LLINE=58, LSE_RLINE=67 */ ;   // d:/lattice/kurs12/statemachine/source/matrix_keyboard.v(33[12] 79[6])
    defparam KeyCode_i0_i4.GSR = "ENABLED";
    LUT4 i25_2_lut_rep_10 (.A(KeyPressed_N_186), .B(KeyPressed_N_188), .Z(n834)) /* synthesis lut_function=(A+(B)) */ ;   // d:/lattice/kurs12/statemachine/source/matrix_keyboard.v(69[15] 71[9])
    defparam i25_2_lut_rep_10.init = 16'heeee;
    LUT4 i618_3_lut (.A(KeyBuffer[10]), .B(KeyBuffer[11]), .C(KeyCounter[0]), 
         .Z(n720)) /* synthesis lut_function=(A (B+!(C))+!A (B (C))) */ ;
    defparam i618_3_lut.init = 16'hcaca;
    L6MUX21 i641 (.D0(n739), .D1(n740), .SD(KeyCounter[3]), .Z(n743));
    LUT4 i617_3_lut (.A(KeyBuffer[8]), .B(KeyBuffer[9]), .C(KeyCounter[0]), 
         .Z(n719)) /* synthesis lut_function=(A (B+!(C))+!A (B (C))) */ ;
    defparam i617_3_lut.init = 16'hcaca;
    LUT4 i27_2_lut_rep_9_3_lut (.A(KeyPressed_N_186), .B(KeyPressed_N_188), 
         .C(State[2]), .Z(Clock_enable_7)) /* synthesis lut_function=(A (C)+!A (B (C))) */ ;   // d:/lattice/kurs12/statemachine/source/matrix_keyboard.v(69[15] 71[9])
    defparam i27_2_lut_rep_9_3_lut.init = 16'he0e0;
    LUT4 i613_3_lut (.A(KeyBuffer[0]), .B(KeyBuffer[1]), .C(KeyCounter[0]), 
         .Z(n715)) /* synthesis lut_function=(A (B+!(C))+!A (B (C))) */ ;
    defparam i613_3_lut.init = 16'hcaca;
    FD1P3AX KeyCode_i0_i3 (.D(KeyCounter[3]), .SP(Clock_enable_41), .CK(Clock), 
            .Q(KeyCode[3])) /* synthesis LSE_LINE_FILE_ID=7, LSE_LCOL=17, LSE_RCOL=3, LSE_LLINE=58, LSE_RLINE=67 */ ;   // d:/lattice/kurs12/statemachine/source/matrix_keyboard.v(33[12] 79[6])
    defparam KeyCode_i0_i3.GSR = "ENABLED";
    FD1P3AX KeyCode_i0_i2 (.D(KeyCounter[2]), .SP(Clock_enable_41), .CK(Clock), 
            .Q(KeyCode[2])) /* synthesis LSE_LINE_FILE_ID=7, LSE_LCOL=17, LSE_RCOL=3, LSE_LLINE=58, LSE_RLINE=67 */ ;   // d:/lattice/kurs12/statemachine/source/matrix_keyboard.v(33[12] 79[6])
    defparam KeyCode_i0_i2.GSR = "ENABLED";
    FD1P3AX KeyCode_i0_i1 (.D(KeyCounter[1]), .SP(Clock_enable_41), .CK(Clock), 
            .Q(KeyCode[1])) /* synthesis LSE_LINE_FILE_ID=7, LSE_LCOL=17, LSE_RCOL=3, LSE_LLINE=58, LSE_RLINE=67 */ ;   // d:/lattice/kurs12/statemachine/source/matrix_keyboard.v(33[12] 79[6])
    defparam KeyCode_i0_i1.GSR = "ENABLED";
    L6MUX21 i642 (.D0(n741), .D1(n742), .SD(KeyCounter[3]), .Z(n744));
    L6MUX21 i637 (.D0(n731), .D1(n732), .SD(KeyCounter[2]), .Z(n739));
    L6MUX21 i638 (.D0(n733), .D1(n734), .SD(KeyCounter[2]), .Z(n740));
    FD1S3AY State_FSM_i2 (.D(n335), .CK(Clock), .Q(State[0]));   // d:/lattice/kurs12/statemachine/source/matrix_keyboard.v(34[4] 78[11])
    defparam State_FSM_i2.GSR = "ENABLED";
    L6MUX21 i639 (.D0(n735), .D1(n736), .SD(KeyCounter[2]), .Z(n741));
    L6MUX21 i640 (.D0(n737), .D1(n738), .SD(KeyCounter[2]), .Z(n742));
    PFUMX i634 (.BLUT(n725), .ALUT(n726), .C0(KeyCounter[1]), .Z(n736));
    PFUMX i635 (.BLUT(n727), .ALUT(n728), .C0(KeyCounter[1]), .Z(n737));
    PFUMX i636 (.BLUT(n729), .ALUT(n730), .C0(KeyCounter[1]), .Z(n738));
    FD1S3IX State_FSM_i1 (.D(State[0]), .CK(Clock), .CD(n97), .Q(\State[1] ));   // d:/lattice/kurs12/statemachine/source/matrix_keyboard.v(34[4] 78[11])
    defparam State_FSM_i1.GSR = "ENABLED";
    FD1P3AX KeyBuffer_i0_i6 (.D(KeyRows_c_2), .SP(Clock_enable_42), .CK(Clock), 
            .Q(KeyBuffer[6])) /* synthesis LSE_LINE_FILE_ID=7, LSE_LCOL=17, LSE_RCOL=3, LSE_LLINE=58, LSE_RLINE=67 */ ;   // d:/lattice/kurs12/statemachine/source/matrix_keyboard.v(33[12] 79[6])
    defparam KeyBuffer_i0_i6.GSR = "ENABLED";
    LUT4 i615_3_lut (.A(KeyBuffer[4]), .B(KeyBuffer[5]), .C(KeyCounter[0]), 
         .Z(n717)) /* synthesis lut_function=(A (B+!(C))+!A (B (C))) */ ;
    defparam i615_3_lut.init = 16'hcaca;
    LUT4 i616_3_lut (.A(KeyBuffer[6]), .B(KeyBuffer[7]), .C(KeyCounter[0]), 
         .Z(n718)) /* synthesis lut_function=(A (B+!(C))+!A (B (C))) */ ;
    defparam i616_3_lut.init = 16'hcaca;
    LUT4 i696_4_lut (.A(KeyPressed_N_188), .B(\State[1] ), .C(State[0]), 
         .D(KeyPressed_N_186), .Z(Clock_enable_43)) /* synthesis lut_function=(A (B)+!A (B+!(C+(D)))) */ ;   // d:/lattice/kurs12/statemachine/source/matrix_keyboard.v(34[4] 78[11])
    defparam i696_4_lut.init = 16'hcccd;
    LUT4 i687_2_lut (.A(Clock_enable_43), .B(State[2]), .Z(n417)) /* synthesis lut_function=(!((B)+!A)) */ ;
    defparam i687_2_lut.init = 16'h2222;
    LUT4 i210_3_lut_4_lut (.A(KeyPressed_N_186), .B(KeyPressed_N_188), .C(\State[1] ), 
         .D(State[2]), .Z(n315)) /* synthesis lut_function=(A (C)+!A (B (C)+!B (C+(D)))) */ ;   // d:/lattice/kurs12/statemachine/source/matrix_keyboard.v(69[15] 71[9])
    defparam i210_3_lut_4_lut.init = 16'hf1f0;
    FD1P3IX KeyCounter_i0_i3 (.D(n45[3]), .SP(Clock_enable_43), .CD(n417), 
            .CK(Clock), .Q(KeyCounter[3])) /* synthesis LSE_LINE_FILE_ID=7, LSE_LCOL=17, LSE_RCOL=3, LSE_LLINE=58, LSE_RLINE=67 */ ;   // d:/lattice/kurs12/statemachine/source/matrix_keyboard.v(33[12] 79[6])
    defparam KeyCounter_i0_i3.GSR = "ENABLED";
    LUT4 i4_4_lut (.A(n837), .B(KeyCounter[4]), .C(KeyCounter[3]), .D(KeyBuffer[31]), 
         .Z(KeyPressed_N_188)) /* synthesis lut_function=(!((((D)+!C)+!B)+!A)) */ ;   // d:/lattice/kurs12/statemachine/source/matrix_keyboard.v(66[18:47])
    defparam i4_4_lut.init = 16'h0080;
    
endmodule
//
// Verilog Description of module \DisplayMultiplex(FREQUENCY_HZ=14000000,SWITCH_PERIOD_US=2000) 
//

module \DisplayMultiplex(FREQUENCY_HZ=14000000,SWITCH_PERIOD_US=2000)  (Data, 
            Clock, SwitchCathode, n839, Cathodes_c_1, \State[1] , 
            Clock_enable_35, Cathodes_c_2, Cathodes_c_6, Clock_enable_21, 
            Cathodes_c_3, Clock_enable_11, Clock_enable_25, Clock_enable_42, 
            Clock_enable_32, n835, Clock_enable_17, Clock_enable_29, 
            n836, Cathodes_c_5, Cathodes_c_7, GND_net, n97, Segments_c_6, 
            Segments_c_0, Segments_c_1, Segments_c_4, Segments_c_3, 
            Segments_c_5, Segments_c_2) /* synthesis syn_module_defined=1 */ ;
    input [19:0]Data;
    input Clock;
    output SwitchCathode;
    output n839;
    output Cathodes_c_1;
    input \State[1] ;
    output Clock_enable_35;
    output Cathodes_c_2;
    output Cathodes_c_6;
    output Clock_enable_21;
    output Cathodes_c_3;
    output Clock_enable_11;
    output Clock_enable_25;
    output Clock_enable_42;
    output Clock_enable_32;
    output n835;
    output Clock_enable_17;
    output Clock_enable_29;
    output n836;
    output Cathodes_c_5;
    output Cathodes_c_7;
    input GND_net;
    output n97;
    output Segments_c_6;
    output Segments_c_0;
    output Segments_c_1;
    output Segments_c_4;
    output Segments_c_3;
    output Segments_c_5;
    output Segments_c_2;
    
    wire Clock /* synthesis SET_AS_NETWORK=Clock, is_clock=1 */ ;   // d:/lattice/kurs12/statemachine/source/top.v(11[7:12])
    
    wire n748, n749;
    wire [31:0]TempData_3__N_34;
    
    wire n751, n706, n703, n704, Enable, n688, n662, n367, n365, 
        n840;
    wire [2:0]n17;
    
    wire n385;
    wire [3:0]TempData;   // d:/lattice/kurs12/statemachine/source/display_multiplex.v(58[13:21])
    
    wire n746, Visible_6__N_23, Visible_6__N_25;
    wire [7:0]Visible;   // d:/lattice/kurs12/statemachine/source/display_multiplex.v(18[20:27])
    
    wire Visible_6__N_27, n660, n841, n707, n383, n710, n709, 
        n14, n747, n787, n750;
    
    PFUMX i649 (.BLUT(n748), .ALUT(n749), .C0(TempData_3__N_34[3]), .Z(n751));
    LUT4 i604_3_lut (.A(Data[1]), .B(Data[6]), .C(TempData_3__N_34[3]), 
         .Z(n706)) /* synthesis lut_function=(A (B+!(C))+!A (B (C))) */ ;
    defparam i604_3_lut.init = 16'hcaca;
    FD1P3AX Selector_107__i1 (.D(n839), .SP(SwitchCathode), .CK(Clock), 
            .Q(TempData_3__N_34[2]));   // d:/lattice/kurs12/statemachine/source/display_multiplex.v(50[17:32])
    defparam Selector_107__i1.GSR = "ENABLED";
    L6MUX21 i603 (.D0(n703), .D1(n704), .SD(TempData_3__N_34[4]), .Z(Enable));
    PFUMX i601 (.BLUT(n688), .ALUT(n662), .C0(TempData_3__N_34[3]), .Z(n703));
    PFUMX i602 (.BLUT(n367), .ALUT(n365), .C0(TempData_3__N_34[3]), .Z(n704));
    LUT4 i411_2_lut_3_lut (.A(TempData_3__N_34[3]), .B(TempData_3__N_34[4]), 
         .C(TempData_3__N_34[2]), .Z(Cathodes_c_1)) /* synthesis lut_function=(!(A+(B+!(C)))) */ ;   // d:/lattice/kurs12/statemachine/source/display_multiplex.v(55[20:38])
    defparam i411_2_lut_3_lut.init = 16'h1010;
    LUT4 n712_bdd_4_lut_4_lut_else_4_lut (.A(TempData_3__N_34[2]), .B(TempData_3__N_34[3]), 
         .C(Data[8]), .D(Data[3]), .Z(n840)) /* synthesis lut_function=(!(A+!(B (C)+!B (D)))) */ ;   // d:/lattice/kurs12/statemachine/source/display_multiplex.v(55[20:38])
    defparam n712_bdd_4_lut_4_lut_else_4_lut.init = 16'h5140;
    FD1P3AX Selector_107__i3 (.D(n17[2]), .SP(SwitchCathode), .CK(Clock), 
            .Q(TempData_3__N_34[4]));   // d:/lattice/kurs12/statemachine/source/display_multiplex.v(50[17:32])
    defparam Selector_107__i3.GSR = "ENABLED";
    LUT4 i484_3_lut (.A(TempData_3__N_34[4]), .B(TempData_3__N_34[3]), .C(TempData_3__N_34[2]), 
         .Z(n17[2])) /* synthesis lut_function=(!(A (B (C))+!A !(B (C)))) */ ;   // d:/lattice/kurs12/statemachine/source/display_multiplex.v(50[17:32])
    defparam i484_3_lut.init = 16'h6a6a;
    LUT4 i419_2_lut_2_lut (.A(TempData_3__N_34[2]), .B(n385), .Z(TempData[2])) /* synthesis lut_function=(!(A+!(B))) */ ;   // d:/lattice/kurs12/statemachine/source/display_multiplex.v(55[20:38])
    defparam i419_2_lut_2_lut.init = 16'h4444;
    FD1P3AX Selector_107__i2 (.D(n17[1]), .SP(SwitchCathode), .CK(Clock), 
            .Q(TempData_3__N_34[3]));   // d:/lattice/kurs12/statemachine/source/display_multiplex.v(50[17:32])
    defparam Selector_107__i2.GSR = "ENABLED";
    LUT4 i1_2_lut_3_lut_4_lut_4_lut (.A(TempData_3__N_34[2]), .B(\State[1] ), 
         .C(TempData_3__N_34[4]), .D(TempData_3__N_34[3]), .Z(Clock_enable_35)) /* synthesis lut_function=(!(A+((C+!(D))+!B))) */ ;   // d:/lattice/kurs12/statemachine/source/display_multiplex.v(55[20:38])
    defparam i1_2_lut_3_lut_4_lut_4_lut.init = 16'h0400;
    LUT4 i477_2_lut (.A(TempData_3__N_34[3]), .B(TempData_3__N_34[2]), .Z(n17[1])) /* synthesis lut_function=(!(A (B)+!A !(B))) */ ;   // d:/lattice/kurs12/statemachine/source/display_multiplex.v(50[17:32])
    defparam i477_2_lut.init = 16'h6666;
    LUT4 i412_2_lut_3_lut_3_lut (.A(TempData_3__N_34[2]), .B(TempData_3__N_34[4]), 
         .C(TempData_3__N_34[3]), .Z(Cathodes_c_2)) /* synthesis lut_function=(!(A+(B+!(C)))) */ ;   // d:/lattice/kurs12/statemachine/source/display_multiplex.v(55[20:38])
    defparam i412_2_lut_3_lut_3_lut.init = 16'h1010;
    LUT4 i381_2_lut_3_lut_3_lut (.A(TempData_3__N_34[2]), .B(TempData_3__N_34[4]), 
         .C(TempData_3__N_34[3]), .Z(Cathodes_c_6)) /* synthesis lut_function=(!(A+!(B (C)))) */ ;   // d:/lattice/kurs12/statemachine/source/display_multiplex.v(55[20:38])
    defparam i381_2_lut_3_lut_3_lut.init = 16'h4040;
    LUT4 i1_2_lut_3_lut_4_lut_4_lut_adj_3 (.A(TempData_3__N_34[2]), .B(\State[1] ), 
         .C(TempData_3__N_34[4]), .D(TempData_3__N_34[3]), .Z(Clock_enable_21)) /* synthesis lut_function=(!(A+!(B (C (D))))) */ ;   // d:/lattice/kurs12/statemachine/source/display_multiplex.v(55[20:38])
    defparam i1_2_lut_3_lut_4_lut_4_lut_adj_3.init = 16'h4000;
    LUT4 i644_3_lut (.A(Data[0]), .B(Data[4]), .C(TempData_3__N_34[2]), 
         .Z(n746)) /* synthesis lut_function=(A (B+!(C))+!A (B (C))) */ ;
    defparam i644_3_lut.init = 16'hcaca;
    LUT4 i260_3_lut_3_lut (.A(TempData_3__N_34[2]), .B(Visible_6__N_23), 
         .C(Data[19]), .Z(n365)) /* synthesis lut_function=(A (C)+!A (B+(C))) */ ;   // d:/lattice/kurs12/statemachine/source/display_multiplex.v(55[20:38])
    defparam i260_3_lut_3_lut.init = 16'hf4f4;
    LUT4 i413_2_lut_3_lut (.A(TempData_3__N_34[3]), .B(TempData_3__N_34[4]), 
         .C(TempData_3__N_34[2]), .Z(Cathodes_c_3)) /* synthesis lut_function=(!((B+!(C))+!A)) */ ;   // d:/lattice/kurs12/statemachine/source/display_multiplex.v(55[20:38])
    defparam i413_2_lut_3_lut.init = 16'h2020;
    LUT4 i262_3_lut_3_lut (.A(TempData_3__N_34[2]), .B(Visible_6__N_25), 
         .C(Visible[5]), .Z(n367)) /* synthesis lut_function=(A (C)+!A (B+(C))) */ ;   // d:/lattice/kurs12/statemachine/source/display_multiplex.v(55[20:38])
    defparam i262_3_lut_3_lut.init = 16'hf4f4;
    LUT4 i1_3_lut_3_lut (.A(TempData_3__N_34[2]), .B(Visible_6__N_27), .C(n660), 
         .Z(n662)) /* synthesis lut_function=(A (C)+!A (B+(C))) */ ;   // d:/lattice/kurs12/statemachine/source/display_multiplex.v(55[20:38])
    defparam i1_3_lut_3_lut.init = 16'hf4f4;
    PFUMX i727 (.BLUT(n840), .ALUT(n841), .C0(TempData_3__N_34[4]), .Z(TempData[3]));
    LUT4 i3_4_lut_4_lut (.A(TempData_3__N_34[2]), .B(Data[4]), .C(Visible_6__N_27), 
         .D(n660), .Z(n688)) /* synthesis lut_function=((B+(C+(D)))+!A) */ ;   // d:/lattice/kurs12/statemachine/source/display_multiplex.v(55[20:38])
    defparam i3_4_lut_4_lut.init = 16'hfffd;
    LUT4 i168_2_lut_3_lut_4_lut (.A(TempData_3__N_34[3]), .B(TempData_3__N_34[4]), 
         .C(\State[1] ), .D(TempData_3__N_34[2]), .Z(Clock_enable_11)) /* synthesis lut_function=(!(A+(B+((D)+!C)))) */ ;   // d:/lattice/kurs12/statemachine/source/display_multiplex.v(55[20:38])
    defparam i168_2_lut_3_lut_4_lut.init = 16'h0010;
    LUT4 i1_2_lut_3_lut_4_lut (.A(TempData_3__N_34[2]), .B(\State[1] ), 
         .C(TempData_3__N_34[4]), .D(TempData_3__N_34[3]), .Z(Clock_enable_25)) /* synthesis lut_function=(!((((D)+!C)+!B)+!A)) */ ;   // d:/lattice/kurs12/statemachine/source/display_multiplex.v(55[20:38])
    defparam i1_2_lut_3_lut_4_lut.init = 16'h0080;
    LUT4 i1_2_lut_3_lut_4_lut_adj_4 (.A(TempData_3__N_34[3]), .B(TempData_3__N_34[4]), 
         .C(\State[1] ), .D(TempData_3__N_34[2]), .Z(Clock_enable_42)) /* synthesis lut_function=(!(A+(B+!(C (D))))) */ ;   // d:/lattice/kurs12/statemachine/source/display_multiplex.v(55[20:38])
    defparam i1_2_lut_3_lut_4_lut_adj_4.init = 16'h1000;
    LUT4 i1_2_lut_3_lut_4_lut_adj_5 (.A(TempData_3__N_34[2]), .B(\State[1] ), 
         .C(TempData_3__N_34[4]), .D(TempData_3__N_34[3]), .Z(Clock_enable_32)) /* synthesis lut_function=(!(((C+!(D))+!B)+!A)) */ ;   // d:/lattice/kurs12/statemachine/source/display_multiplex.v(55[20:38])
    defparam i1_2_lut_3_lut_4_lut_adj_5.init = 16'h0800;
    LUT4 i693_2_lut_rep_11_3_lut (.A(TempData_3__N_34[3]), .B(TempData_3__N_34[4]), 
         .C(TempData_3__N_34[2]), .Z(n835)) /* synthesis lut_function=(!(A+(B+(C)))) */ ;   // d:/lattice/kurs12/statemachine/source/display_multiplex.v(55[20:38])
    defparam i693_2_lut_rep_11_3_lut.init = 16'h0101;
    LUT4 i12_1_lut_rep_15 (.A(TempData_3__N_34[2]), .Z(n839)) /* synthesis lut_function=(!(A)) */ ;   // d:/lattice/kurs12/statemachine/source/display_multiplex.v(55[20:38])
    defparam i12_1_lut_rep_15.init = 16'h5555;
    PFUMX i606 (.BLUT(n706), .ALUT(n707), .C0(TempData_3__N_34[4]), .Z(n383));
    LUT4 i608_3_lut (.A(Data[12]), .B(Data[17]), .C(TempData_3__N_34[3]), 
         .Z(n710)) /* synthesis lut_function=(A (B+!(C))+!A (B (C))) */ ;
    defparam i608_3_lut.init = 16'hcaca;
    LUT4 i1_2_lut_3_lut_4_lut_adj_6 (.A(TempData_3__N_34[2]), .B(\State[1] ), 
         .C(TempData_3__N_34[4]), .D(TempData_3__N_34[3]), .Z(Clock_enable_17)) /* synthesis lut_function=(A (B (C (D)))) */ ;   // d:/lattice/kurs12/statemachine/source/display_multiplex.v(55[20:38])
    defparam i1_2_lut_3_lut_4_lut_adj_6.init = 16'h8000;
    LUT4 n712_bdd_4_lut_4_lut_then_4_lut (.A(TempData_3__N_34[2]), .B(TempData_3__N_34[3]), 
         .C(Data[18]), .D(Data[13]), .Z(n841)) /* synthesis lut_function=(!(A+!(B (C)+!B (D)))) */ ;   // d:/lattice/kurs12/statemachine/source/display_multiplex.v(55[20:38])
    defparam n712_bdd_4_lut_4_lut_then_4_lut.init = 16'h5140;
    LUT4 i607_3_lut (.A(Data[2]), .B(Data[7]), .C(TempData_3__N_34[3]), 
         .Z(n709)) /* synthesis lut_function=(A (B+!(C))+!A (B (C))) */ ;
    defparam i607_3_lut.init = 16'hcaca;
    LUT4 i418_2_lut_2_lut (.A(TempData_3__N_34[2]), .B(n383), .Z(TempData[1])) /* synthesis lut_function=(!(A+!(B))) */ ;   // d:/lattice/kurs12/statemachine/source/display_multiplex.v(55[20:38])
    defparam i418_2_lut_2_lut.init = 16'h4444;
    LUT4 i647_3_lut (.A(Data[15]), .B(Data[19]), .C(TempData_3__N_34[2]), 
         .Z(n749)) /* synthesis lut_function=(A (B+!(C))+!A (B (C))) */ ;
    defparam i647_3_lut.init = 16'hcaca;
    LUT4 i408_4_lut_4_lut_4_lut (.A(TempData_3__N_34[2]), .B(n385), .C(n383), 
         .D(TempData[0]), .Z(n14)) /* synthesis lut_function=(!(A (D)+!A !(B+(C+!(D))))) */ ;   // d:/lattice/kurs12/statemachine/source/display_multiplex.v(55[20:38])
    defparam i408_4_lut_4_lut_4_lut.init = 16'h54ff;
    LUT4 i2_3_lut (.A(Data[9]), .B(Visible_6__N_25), .C(Visible[5]), .Z(n660)) /* synthesis lut_function=(A+(B+(C))) */ ;   // d:/lattice/kurs12/statemachine/source/display_multiplex.v(25[34:66])
    defparam i2_3_lut.init = 16'hfefe;
    LUT4 i646_3_lut (.A(Data[10]), .B(Data[14]), .C(TempData_3__N_34[2]), 
         .Z(n748)) /* synthesis lut_function=(A (B+!(C))+!A (B (C))) */ ;
    defparam i646_3_lut.init = 16'hcaca;
    LUT4 i645_3_lut (.A(Data[5]), .B(Data[9]), .C(TempData_3__N_34[2]), 
         .Z(n747)) /* synthesis lut_function=(A (B+!(C))+!A (B (C))) */ ;
    defparam i645_3_lut.init = 16'hcaca;
    LUT4 i243_2_lut_3_lut_4_lut (.A(TempData_3__N_34[3]), .B(TempData_3__N_34[4]), 
         .C(\State[1] ), .D(TempData_3__N_34[2]), .Z(Clock_enable_29)) /* synthesis lut_function=(!(A+(((D)+!C)+!B))) */ ;   // d:/lattice/kurs12/statemachine/source/display_multiplex.v(55[20:38])
    defparam i243_2_lut_3_lut_4_lut.init = 16'h0040;
    LUT4 i3_4_lut (.A(Data[5]), .B(Data[8]), .C(Data[7]), .D(Data[6]), 
         .Z(Visible_6__N_27)) /* synthesis lut_function=(A+(B+(C+(D)))) */ ;   // d:/lattice/kurs12/statemachine/source/display_multiplex.v(25[34:50])
    defparam i3_4_lut.init = 16'hfffe;
    LUT4 i3_4_lut_adj_7 (.A(Data[10]), .B(Data[13]), .C(Data[12]), .D(Data[11]), 
         .Z(Visible_6__N_25)) /* synthesis lut_function=(A+(B+(C+(D)))) */ ;   // d:/lattice/kurs12/statemachine/source/display_multiplex.v(25[34:50])
    defparam i3_4_lut_adj_7.init = 16'hfffe;
    LUT4 i2_3_lut_adj_8 (.A(Data[14]), .B(Visible_6__N_23), .C(Data[19]), 
         .Z(Visible[5])) /* synthesis lut_function=(A+(B+(C))) */ ;   // d:/lattice/kurs12/statemachine/source/display_multiplex.v(25[34:66])
    defparam i2_3_lut_adj_8.init = 16'hfefe;
    LUT4 i3_4_lut_adj_9 (.A(Data[15]), .B(Data[18]), .C(Data[17]), .D(Data[16]), 
         .Z(Visible_6__N_23)) /* synthesis lut_function=(A+(B+(C+(D)))) */ ;   // d:/lattice/kurs12/statemachine/source/display_multiplex.v(25[34:50])
    defparam i3_4_lut_adj_9.init = 16'hfffe;
    LUT4 TempData_2__bdd_4_lut_709_4_lut (.A(TempData_3__N_34[2]), .B(n383), 
         .C(n385), .D(TempData[0]), .Z(n787)) /* synthesis lut_function=(A+!(B (C+(D))+!B !((D)+!C))) */ ;   // d:/lattice/kurs12/statemachine/source/display_multiplex.v(55[20:38])
    defparam TempData_2__bdd_4_lut_709_4_lut.init = 16'hbbaf;
    LUT4 i690_2_lut_rep_12_3_lut (.A(TempData_3__N_34[3]), .B(TempData_3__N_34[4]), 
         .C(TempData_3__N_34[2]), .Z(n836)) /* synthesis lut_function=(!(A+((C)+!B))) */ ;   // d:/lattice/kurs12/statemachine/source/display_multiplex.v(55[20:38])
    defparam i690_2_lut_rep_12_3_lut.init = 16'h0404;
    LUT4 i416_2_lut_3_lut (.A(TempData_3__N_34[3]), .B(TempData_3__N_34[4]), 
         .C(TempData_3__N_34[2]), .Z(Cathodes_c_5)) /* synthesis lut_function=(!(A+!(B (C)))) */ ;   // d:/lattice/kurs12/statemachine/source/display_multiplex.v(55[20:38])
    defparam i416_2_lut_3_lut.init = 16'h4040;
    LUT4 i605_3_lut (.A(Data[11]), .B(Data[16]), .C(TempData_3__N_34[3]), 
         .Z(n707)) /* synthesis lut_function=(A (B+!(C))+!A (B (C))) */ ;
    defparam i605_3_lut.init = 16'hcaca;
    PFUMX i609 (.BLUT(n709), .ALUT(n710), .C0(TempData_3__N_34[4]), .Z(n385));
    PFUMX i648 (.BLUT(n746), .ALUT(n747), .C0(TempData_3__N_34[3]), .Z(n750));
    LUT4 i382_2_lut_3_lut (.A(TempData_3__N_34[3]), .B(TempData_3__N_34[4]), 
         .C(TempData_3__N_34[2]), .Z(Cathodes_c_7)) /* synthesis lut_function=(A (B (C))) */ ;   // d:/lattice/kurs12/statemachine/source/display_multiplex.v(55[20:38])
    defparam i382_2_lut_3_lut.init = 16'h8080;
    L6MUX21 i650 (.D0(n750), .D1(n751), .SD(TempData_3__N_34[4]), .Z(TempData[0]));
    \StrobeGenerator(FREQUENCY_HZ=14000000,PERIOD_US=2000)  StrobeGenerator0 (.Clock(Clock), 
            .SwitchCathode(SwitchCathode), .GND_net(GND_net), .n97(n97)) /* synthesis syn_module_defined=1 */ ;   // d:/lattice/kurs12/statemachine/source/display_multiplex.v(34[4] 38[3])
    Decoder7seg Decoder7seg0 (.Enable(Enable), .Segments_c_6(Segments_c_6), 
            .Segments_c_0(Segments_c_0), .Segments_c_1(Segments_c_1), .TempData({TempData}), 
            .n383(n383), .n385(n385), .n14(n14), .Segments_c_4(Segments_c_4), 
            .\TempData_3__N_34[2] (TempData_3__N_34[2]), .Segments_c_3(Segments_c_3), 
            .Segments_c_5(Segments_c_5), .Segments_c_2(Segments_c_2), .n787(n787)) /* synthesis syn_module_defined=1 */ ;   // d:/lattice/kurs12/statemachine/source/display_multiplex.v(69[4] 73[3])
    
endmodule
//
// Verilog Description of module \StrobeGenerator(FREQUENCY_HZ=14000000,PERIOD_US=2000) 
//

module \StrobeGenerator(FREQUENCY_HZ=14000000,PERIOD_US=2000)  (Clock, SwitchCathode, 
            GND_net, n97) /* synthesis syn_module_defined=1 */ ;
    input Clock;
    output SwitchCathode;
    input GND_net;
    output n97;
    
    wire Clock /* synthesis SET_AS_NETWORK=Clock, is_clock=1 */ ;   // d:/lattice/kurs12/statemachine/source/top.v(11[7:12])
    wire [14:0]Counter;   // d:/lattice/kurs12/statemachine/source/strobe_generator.v(20[18:25])
    
    wire Counter_14__N_75;
    wire [14:0]Counter_14__N_60;
    
    wire n15, n13, n10, n12, n8, n585, n586, n590, n584, n587, 
        n588, n589;
    
    FD1S3JX Counter_i0 (.D(Counter_14__N_60[0]), .CK(Clock), .PD(Counter_14__N_75), 
            .Q(Counter[0])) /* synthesis LSE_LINE_FILE_ID=4, LSE_LCOL=4, LSE_RCOL=3, LSE_LLINE=34, LSE_RLINE=38 */ ;   // d:/lattice/kurs12/statemachine/source/strobe_generator.v(26[12] 32[6])
    defparam Counter_i0.GSR = "ENABLED";
    FD1S3AX Strobe_13 (.D(Counter_14__N_75), .CK(Clock), .Q(SwitchCathode)) /* synthesis LSE_LINE_FILE_ID=4, LSE_LCOL=4, LSE_RCOL=3, LSE_LLINE=34, LSE_RLINE=38 */ ;   // d:/lattice/kurs12/statemachine/source/strobe_generator.v(26[12] 32[6])
    defparam Strobe_13.GSR = "ENABLED";
    LUT4 i684_4_lut (.A(n15), .B(n13), .C(Counter[11]), .D(n10), .Z(Counter_14__N_75)) /* synthesis lut_function=(!(A+(B+(C+(D))))) */ ;   // d:/lattice/kurs12/statemachine/source/strobe_generator.v(26[15:23])
    defparam i684_4_lut.init = 16'h0001;
    LUT4 i6_4_lut (.A(Counter[10]), .B(Counter[9]), .C(Counter[2]), .D(Counter[12]), 
         .Z(n15)) /* synthesis lut_function=(A+(B+(C+(D)))) */ ;   // d:/lattice/kurs12/statemachine/source/strobe_generator.v(26[15:23])
    defparam i6_4_lut.init = 16'hfffe;
    LUT4 i4_2_lut (.A(Counter[1]), .B(Counter[7]), .Z(n13)) /* synthesis lut_function=(A+(B)) */ ;   // d:/lattice/kurs12/statemachine/source/strobe_generator.v(26[15:23])
    defparam i4_2_lut.init = 16'heeee;
    LUT4 i1_4_lut (.A(Counter[8]), .B(Counter[5]), .C(n12), .D(n8), 
         .Z(n10)) /* synthesis lut_function=(A+(B+(C+(D)))) */ ;   // d:/lattice/kurs12/statemachine/source/strobe_generator.v(26[15:23])
    defparam i1_4_lut.init = 16'hfffe;
    LUT4 i5_4_lut (.A(Counter[13]), .B(Counter[4]), .C(Counter[14]), .D(Counter[0]), 
         .Z(n12)) /* synthesis lut_function=(A+(B+(C+(D)))) */ ;   // d:/lattice/kurs12/statemachine/source/strobe_generator.v(26[15:23])
    defparam i5_4_lut.init = 16'hfffe;
    CCU2D sub_6_add_2_5 (.A0(Counter[3]), .B0(GND_net), .C0(GND_net), 
          .D0(GND_net), .A1(Counter[4]), .B1(GND_net), .C1(GND_net), 
          .D1(GND_net), .CIN(n585), .COUT(n586), .S0(Counter_14__N_60[3]), 
          .S1(Counter_14__N_60[4]));   // d:/lattice/kurs12/statemachine/source/strobe_generator.v(30[15:29])
    defparam sub_6_add_2_5.INIT0 = 16'h5555;
    defparam sub_6_add_2_5.INIT1 = 16'h5555;
    defparam sub_6_add_2_5.INJECT1_0 = "NO";
    defparam sub_6_add_2_5.INJECT1_1 = "NO";
    LUT4 i1_2_lut (.A(Counter[6]), .B(Counter[3]), .Z(n8)) /* synthesis lut_function=(A+(B)) */ ;   // d:/lattice/kurs12/statemachine/source/strobe_generator.v(26[15:23])
    defparam i1_2_lut.init = 16'heeee;
    CCU2D sub_6_add_2_15 (.A0(Counter[13]), .B0(GND_net), .C0(GND_net), 
          .D0(GND_net), .A1(Counter[14]), .B1(GND_net), .C1(GND_net), 
          .D1(GND_net), .CIN(n590), .S0(Counter_14__N_60[13]), .S1(Counter_14__N_60[14]));   // d:/lattice/kurs12/statemachine/source/strobe_generator.v(30[15:29])
    defparam sub_6_add_2_15.INIT0 = 16'h5555;
    defparam sub_6_add_2_15.INIT1 = 16'h5555;
    defparam sub_6_add_2_15.INJECT1_0 = "NO";
    defparam sub_6_add_2_15.INJECT1_1 = "NO";
    CCU2D sub_6_add_2_1 (.A0(GND_net), .B0(GND_net), .C0(GND_net), .D0(GND_net), 
          .A1(Counter[0]), .B1(GND_net), .C1(GND_net), .D1(GND_net), 
          .COUT(n584), .S1(Counter_14__N_60[0]));   // d:/lattice/kurs12/statemachine/source/strobe_generator.v(30[15:29])
    defparam sub_6_add_2_1.INIT0 = 16'hF000;
    defparam sub_6_add_2_1.INIT1 = 16'h5555;
    defparam sub_6_add_2_1.INJECT1_0 = "NO";
    defparam sub_6_add_2_1.INJECT1_1 = "NO";
    CCU2D sub_6_add_2_9 (.A0(Counter[7]), .B0(GND_net), .C0(GND_net), 
          .D0(GND_net), .A1(Counter[8]), .B1(GND_net), .C1(GND_net), 
          .D1(GND_net), .CIN(n587), .COUT(n588), .S0(Counter_14__N_60[7]), 
          .S1(Counter_14__N_60[8]));   // d:/lattice/kurs12/statemachine/source/strobe_generator.v(30[15:29])
    defparam sub_6_add_2_9.INIT0 = 16'h5555;
    defparam sub_6_add_2_9.INIT1 = 16'h5555;
    defparam sub_6_add_2_9.INJECT1_0 = "NO";
    defparam sub_6_add_2_9.INJECT1_1 = "NO";
    CCU2D sub_6_add_2_11 (.A0(Counter[9]), .B0(GND_net), .C0(GND_net), 
          .D0(GND_net), .A1(Counter[10]), .B1(GND_net), .C1(GND_net), 
          .D1(GND_net), .CIN(n588), .COUT(n589), .S0(Counter_14__N_60[9]), 
          .S1(Counter_14__N_60[10]));   // d:/lattice/kurs12/statemachine/source/strobe_generator.v(30[15:29])
    defparam sub_6_add_2_11.INIT0 = 16'h5555;
    defparam sub_6_add_2_11.INIT1 = 16'h5555;
    defparam sub_6_add_2_11.INJECT1_0 = "NO";
    defparam sub_6_add_2_11.INJECT1_1 = "NO";
    FD1S3JX Counter_i14 (.D(Counter_14__N_60[14]), .CK(Clock), .PD(Counter_14__N_75), 
            .Q(Counter[14])) /* synthesis LSE_LINE_FILE_ID=4, LSE_LCOL=4, LSE_RCOL=3, LSE_LLINE=34, LSE_RLINE=38 */ ;   // d:/lattice/kurs12/statemachine/source/strobe_generator.v(26[12] 32[6])
    defparam Counter_i14.GSR = "ENABLED";
    CCU2D sub_6_add_2_3 (.A0(Counter[1]), .B0(GND_net), .C0(GND_net), 
          .D0(GND_net), .A1(Counter[2]), .B1(GND_net), .C1(GND_net), 
          .D1(GND_net), .CIN(n584), .COUT(n585), .S0(Counter_14__N_60[1]), 
          .S1(Counter_14__N_60[2]));   // d:/lattice/kurs12/statemachine/source/strobe_generator.v(30[15:29])
    defparam sub_6_add_2_3.INIT0 = 16'h5555;
    defparam sub_6_add_2_3.INIT1 = 16'h5555;
    defparam sub_6_add_2_3.INJECT1_0 = "NO";
    defparam sub_6_add_2_3.INJECT1_1 = "NO";
    FD1S3JX Counter_i13 (.D(Counter_14__N_60[13]), .CK(Clock), .PD(Counter_14__N_75), 
            .Q(Counter[13])) /* synthesis LSE_LINE_FILE_ID=4, LSE_LCOL=4, LSE_RCOL=3, LSE_LLINE=34, LSE_RLINE=38 */ ;   // d:/lattice/kurs12/statemachine/source/strobe_generator.v(26[12] 32[6])
    defparam Counter_i13.GSR = "ENABLED";
    FD1S3IX Counter_i12 (.D(Counter_14__N_60[12]), .CK(Clock), .CD(Counter_14__N_75), 
            .Q(Counter[12])) /* synthesis LSE_LINE_FILE_ID=4, LSE_LCOL=4, LSE_RCOL=3, LSE_LLINE=34, LSE_RLINE=38 */ ;   // d:/lattice/kurs12/statemachine/source/strobe_generator.v(26[12] 32[6])
    defparam Counter_i12.GSR = "ENABLED";
    FD1S3JX Counter_i11 (.D(Counter_14__N_60[11]), .CK(Clock), .PD(Counter_14__N_75), 
            .Q(Counter[11])) /* synthesis LSE_LINE_FILE_ID=4, LSE_LCOL=4, LSE_RCOL=3, LSE_LLINE=34, LSE_RLINE=38 */ ;   // d:/lattice/kurs12/statemachine/source/strobe_generator.v(26[12] 32[6])
    defparam Counter_i11.GSR = "ENABLED";
    FD1S3JX Counter_i10 (.D(Counter_14__N_60[10]), .CK(Clock), .PD(Counter_14__N_75), 
            .Q(Counter[10])) /* synthesis LSE_LINE_FILE_ID=4, LSE_LCOL=4, LSE_RCOL=3, LSE_LLINE=34, LSE_RLINE=38 */ ;   // d:/lattice/kurs12/statemachine/source/strobe_generator.v(26[12] 32[6])
    defparam Counter_i10.GSR = "ENABLED";
    FD1S3IX Counter_i9 (.D(Counter_14__N_60[9]), .CK(Clock), .CD(Counter_14__N_75), 
            .Q(Counter[9])) /* synthesis LSE_LINE_FILE_ID=4, LSE_LCOL=4, LSE_RCOL=3, LSE_LLINE=34, LSE_RLINE=38 */ ;   // d:/lattice/kurs12/statemachine/source/strobe_generator.v(26[12] 32[6])
    defparam Counter_i9.GSR = "ENABLED";
    FD1S3JX Counter_i8 (.D(Counter_14__N_60[8]), .CK(Clock), .PD(Counter_14__N_75), 
            .Q(Counter[8])) /* synthesis LSE_LINE_FILE_ID=4, LSE_LCOL=4, LSE_RCOL=3, LSE_LLINE=34, LSE_RLINE=38 */ ;   // d:/lattice/kurs12/statemachine/source/strobe_generator.v(26[12] 32[6])
    defparam Counter_i8.GSR = "ENABLED";
    FD1S3IX Counter_i7 (.D(Counter_14__N_60[7]), .CK(Clock), .CD(Counter_14__N_75), 
            .Q(Counter[7])) /* synthesis LSE_LINE_FILE_ID=4, LSE_LCOL=4, LSE_RCOL=3, LSE_LLINE=34, LSE_RLINE=38 */ ;   // d:/lattice/kurs12/statemachine/source/strobe_generator.v(26[12] 32[6])
    defparam Counter_i7.GSR = "ENABLED";
    FD1S3JX Counter_i6 (.D(Counter_14__N_60[6]), .CK(Clock), .PD(Counter_14__N_75), 
            .Q(Counter[6])) /* synthesis LSE_LINE_FILE_ID=4, LSE_LCOL=4, LSE_RCOL=3, LSE_LLINE=34, LSE_RLINE=38 */ ;   // d:/lattice/kurs12/statemachine/source/strobe_generator.v(26[12] 32[6])
    defparam Counter_i6.GSR = "ENABLED";
    FD1S3IX Counter_i5 (.D(Counter_14__N_60[5]), .CK(Clock), .CD(Counter_14__N_75), 
            .Q(Counter[5])) /* synthesis LSE_LINE_FILE_ID=4, LSE_LCOL=4, LSE_RCOL=3, LSE_LLINE=34, LSE_RLINE=38 */ ;   // d:/lattice/kurs12/statemachine/source/strobe_generator.v(26[12] 32[6])
    defparam Counter_i5.GSR = "ENABLED";
    FD1S3JX Counter_i4 (.D(Counter_14__N_60[4]), .CK(Clock), .PD(Counter_14__N_75), 
            .Q(Counter[4])) /* synthesis LSE_LINE_FILE_ID=4, LSE_LCOL=4, LSE_RCOL=3, LSE_LLINE=34, LSE_RLINE=38 */ ;   // d:/lattice/kurs12/statemachine/source/strobe_generator.v(26[12] 32[6])
    defparam Counter_i4.GSR = "ENABLED";
    FD1S3JX Counter_i3 (.D(Counter_14__N_60[3]), .CK(Clock), .PD(Counter_14__N_75), 
            .Q(Counter[3])) /* synthesis LSE_LINE_FILE_ID=4, LSE_LCOL=4, LSE_RCOL=3, LSE_LLINE=34, LSE_RLINE=38 */ ;   // d:/lattice/kurs12/statemachine/source/strobe_generator.v(26[12] 32[6])
    defparam Counter_i3.GSR = "ENABLED";
    FD1S3JX Counter_i2 (.D(Counter_14__N_60[2]), .CK(Clock), .PD(Counter_14__N_75), 
            .Q(Counter[2])) /* synthesis LSE_LINE_FILE_ID=4, LSE_LCOL=4, LSE_RCOL=3, LSE_LLINE=34, LSE_RLINE=38 */ ;   // d:/lattice/kurs12/statemachine/source/strobe_generator.v(26[12] 32[6])
    defparam Counter_i2.GSR = "ENABLED";
    FD1S3JX Counter_i1 (.D(Counter_14__N_60[1]), .CK(Clock), .PD(Counter_14__N_75), 
            .Q(Counter[1])) /* synthesis LSE_LINE_FILE_ID=4, LSE_LCOL=4, LSE_RCOL=3, LSE_LLINE=34, LSE_RLINE=38 */ ;   // d:/lattice/kurs12/statemachine/source/strobe_generator.v(26[12] 32[6])
    defparam Counter_i1.GSR = "ENABLED";
    CCU2D sub_6_add_2_13 (.A0(Counter[11]), .B0(GND_net), .C0(GND_net), 
          .D0(GND_net), .A1(Counter[12]), .B1(GND_net), .C1(GND_net), 
          .D1(GND_net), .CIN(n589), .COUT(n590), .S0(Counter_14__N_60[11]), 
          .S1(Counter_14__N_60[12]));   // d:/lattice/kurs12/statemachine/source/strobe_generator.v(30[15:29])
    defparam sub_6_add_2_13.INIT0 = 16'h5555;
    defparam sub_6_add_2_13.INIT1 = 16'h5555;
    defparam sub_6_add_2_13.INJECT1_0 = "NO";
    defparam sub_6_add_2_13.INJECT1_1 = "NO";
    CCU2D sub_6_add_2_7 (.A0(Counter[5]), .B0(GND_net), .C0(GND_net), 
          .D0(GND_net), .A1(Counter[6]), .B1(GND_net), .C1(GND_net), 
          .D1(GND_net), .CIN(n586), .COUT(n587), .S0(Counter_14__N_60[5]), 
          .S1(Counter_14__N_60[6]));   // d:/lattice/kurs12/statemachine/source/strobe_generator.v(30[15:29])
    defparam sub_6_add_2_7.INIT0 = 16'h5555;
    defparam sub_6_add_2_7.INIT1 = 16'h5555;
    defparam sub_6_add_2_7.INJECT1_0 = "NO";
    defparam sub_6_add_2_7.INJECT1_1 = "NO";
    LUT4 i14_1_lut (.A(SwitchCathode), .Z(n97)) /* synthesis lut_function=(!(A)) */ ;   // d:/lattice/kurs12/statemachine/source/strobe_generator.v(26[12] 32[6])
    defparam i14_1_lut.init = 16'h5555;
    
endmodule
//
// Verilog Description of module Decoder7seg
//

module Decoder7seg (Enable, Segments_c_6, Segments_c_0, Segments_c_1, 
            TempData, n383, n385, n14, Segments_c_4, \TempData_3__N_34[2] , 
            Segments_c_3, Segments_c_5, Segments_c_2, n787) /* synthesis syn_module_defined=1 */ ;
    input Enable;
    output Segments_c_6;
    output Segments_c_0;
    output Segments_c_1;
    input [3:0]TempData;
    input n383;
    input n385;
    input n14;
    output Segments_c_4;
    input \TempData_3__N_34[2] ;
    output Segments_c_3;
    output Segments_c_5;
    output Segments_c_2;
    input n787;
    
    
    wire n790;
    wire [6:0]Segments_6__N_76;
    
    wire n363, n671, n7, n792, n797, n788, n800;
    
    LUT4 gnd_bdd_2_lut_705 (.A(n790), .B(Enable), .Z(Segments_c_6)) /* synthesis lut_function=(A (B)) */ ;
    defparam gnd_bdd_2_lut_705.init = 16'h8888;
    LUT4 i402_2_lut (.A(Segments_6__N_76[0]), .B(Enable), .Z(Segments_c_0)) /* synthesis lut_function=(A (B)) */ ;   // d:/lattice/kurs12/statemachine/source/decoder_7seg.v(35[4:13])
    defparam i402_2_lut.init = 16'h8888;
    LUT4 i391_2_lut (.A(Segments_6__N_76[1]), .B(Enable), .Z(Segments_c_1)) /* synthesis lut_function=(A (B)) */ ;   // d:/lattice/kurs12/statemachine/source/decoder_7seg.v(35[4:13])
    defparam i391_2_lut.init = 16'h8888;
    PFUMX Data_3__I_0_Mux_0_i15 (.BLUT(n363), .ALUT(n671), .C0(TempData[3]), 
          .Z(Segments_6__N_76[0])) /* synthesis LSE_LINE_FILE_ID=4, LSE_LCOL=4, LSE_RCOL=3, LSE_LLINE=69, LSE_RLINE=73 */ ;
    LUT4 i570_3_lut (.A(TempData[0]), .B(n383), .C(n385), .Z(n671)) /* synthesis lut_function=((B (C)+!B !(C))+!A) */ ;
    defparam i570_3_lut.init = 16'hd7d7;
    PFUMX Data_3__I_0_Mux_4_i15 (.BLUT(n7), .ALUT(n14), .C0(TempData[3]), 
          .Z(Segments_6__N_76[4])) /* synthesis LSE_LINE_FILE_ID=4, LSE_LCOL=4, LSE_RCOL=3, LSE_LLINE=69, LSE_RLINE=73 */ ;
    LUT4 i388_2_lut (.A(Segments_6__N_76[4]), .B(Enable), .Z(Segments_c_4)) /* synthesis lut_function=(A (B)) */ ;   // d:/lattice/kurs12/statemachine/source/decoder_7seg.v(35[4:13])
    defparam i388_2_lut.init = 16'h8888;
    LUT4 Enable_bdd_4_lut_704 (.A(TempData[1]), .B(TempData[0]), .C(TempData[3]), 
         .D(TempData[2]), .Z(n790)) /* synthesis lut_function=(A ((C+!(D))+!B)+!A (B (C+(D))+!B !(C (D)+!C !(D)))) */ ;
    defparam Enable_bdd_4_lut_704.init = 16'he7fa;
    LUT4 Enable_bdd_4_lut (.A(TempData[0]), .B(TempData[3]), .C(TempData[2]), 
         .D(TempData[1]), .Z(n792)) /* synthesis lut_function=(A (B ((D)+!C)+!B !((D)+!C))+!A (B+(C+!(D)))) */ ;
    defparam Enable_bdd_4_lut.init = 16'hdc7d;
    LUT4 i417_3_lut_4_lut (.A(TempData[0]), .B(\TempData_3__N_34[2] ), .C(n383), 
         .D(n385), .Z(n363)) /* synthesis lut_function=(!(A (B+!(C+(D)))+!A !(B+(C+!(D))))) */ ;   // d:/lattice/kurs12/statemachine/source/decoder_7seg.v(15[4] 33[11])
    defparam i417_3_lut_4_lut.init = 16'h7675;
    LUT4 gnd_bdd_2_lut_710 (.A(n797), .B(Enable), .Z(Segments_c_3)) /* synthesis lut_function=(A (B)) */ ;
    defparam gnd_bdd_2_lut_710.init = 16'h8888;
    LUT4 gnd_bdd_2_lut_708 (.A(n792), .B(Enable), .Z(Segments_c_5)) /* synthesis lut_function=(A (B)) */ ;
    defparam gnd_bdd_2_lut_708.init = 16'h8888;
    LUT4 TempData_0__bdd_4_lut_729 (.A(TempData[0]), .B(TempData[3]), .C(TempData[1]), 
         .D(TempData[2]), .Z(n797)) /* synthesis lut_function=(!(A (B (C (D))+!B (C (D)+!C !(D)))+!A !(B ((D)+!C)+!B (C+!(D))))) */ ;
    defparam TempData_0__bdd_4_lut_729.init = 16'h5ebd;
    LUT4 i407_2_lut_3_lut_4_lut (.A(\TempData_3__N_34[2] ), .B(n383), .C(n385), 
         .D(TempData[0]), .Z(n7)) /* synthesis lut_function=(!(A (D)+!A (B (D)+!B (C+(D))))) */ ;   // d:/lattice/kurs12/statemachine/source/decoder_7seg.v(15[4] 33[11])
    defparam i407_2_lut_3_lut_4_lut.init = 16'h00ef;
    LUT4 TempData_2__bdd_3_lut_712_4_lut (.A(\TempData_3__N_34[2] ), .B(n385), 
         .C(TempData[0]), .D(n383), .Z(n788)) /* synthesis lut_function=(A+((C (D)+!C !(D))+!B)) */ ;
    defparam TempData_2__bdd_3_lut_712_4_lut.init = 16'hfbbf;
    LUT4 TempData_2__bdd_4_lut_711 (.A(TempData[2]), .B(TempData[1]), .C(TempData[3]), 
         .D(TempData[0]), .Z(n800)) /* synthesis lut_function=(!(A (B (C)+!B !((D)+!C))+!A !((C+(D))+!B))) */ ;
    defparam TempData_2__bdd_4_lut_711.init = 16'h7f5b;
    LUT4 gnd_bdd_2_lut_715 (.A(n800), .B(Enable), .Z(Segments_c_2)) /* synthesis lut_function=(A (B)) */ ;
    defparam gnd_bdd_2_lut_715.init = 16'h8888;
    PFUMX i702 (.BLUT(n788), .ALUT(n787), .C0(TempData[3]), .Z(Segments_6__N_76[1]));
    
endmodule
